//----------------------------------------------------------------------//
// v	CtH[												//
//																		//
//----------------------------------------------------------------------//
#ifndef Unit1H
#define Unit1H

//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.AppEvnts.hpp>
#include <Vcl.Clipbrd.hpp>
#include <mmsystem.h>
#include "UIniFile.h"
#include "UserFunc.h"
#include "moonage.h"
#include "koyomi.h"
#include "holiday.h"
#include "EvParam.h"

//---------------------------------------------------------------------------
#define SUPPORT_URL _T("http://nekomimi.la.coocan.jp/")

//---------------------------------------------------------------------------
//ftHg̔zF
#define DEF_FgColor		(TColor)0x00ff00	//		
#define DEF_FsColor		(TColor)0x000080	//̉e	Ð
#define DEF_BgColor 	(TColor)0x000000	//wi		
#define DEF_FrmColor	(TColor)0xff0000	//g		
#define DEF_MonColor	(TColor)0x00ffff	//̌`	
#define DEF_ShdColor	(TColor)0x404040	//̉e	ÊDF

//---------------------------------------------------------------------------
#define MAX_ALARM			30		//A[̍őo^
#define MAX_WIN_TIMER		10		//WindowsNo߃^C}[̍őo^
#define MAX_START_TIMER		10		//vNo߃^C}[̍őo^
#define MAX_INTERVAL_TIMER	 5		//C^[o^C}[̍őo^

//őCxgo^
#define MAX_EVENT MAX_ALARM + MAX_WIN_TIMER + MAX_START_TIMER

//Cxg`e[u
struct evnt_tbl {
	int  evtyp;				//Cxg̎
	UnicodeString name;		//Cxg(ZNV)
	UnicodeString dt_msk;	//t}XN
	UnicodeString wk_msk;	//j}XN
	long start;				//X^[g̃JEgl(b)
	long count;				// = hour*3600 + min*60 +sec
	bool active;
	bool done;				//sς݃tO
};

// evtyp
#define EVT_ALARM			0x01	//A[
#define	EVT_WIN_TIMER		0x10	//WindowsNo߃^C}[
#define	EVT_START_TIMER		0x20	//vNo߃^C}[
#define	EVT_INTERVAL_TIMER	0x40	//C^[o^C}[

#define EV_DBLCLICK_BAS		1000	//_uNbNECxg̃x[Xԍ
									// Shift:+1, Ctrl:+2, Alt:+4

//DoEventAction ̖߂l
#define EVST_SOUND		0x01	//TEh炵
#define EVST_BG_IMG		0x02	//wiύX
#define EVST_WLPAPER	0x04	//ǎύX
#define EVST_MESSAGE	0x08	//bZ[W\
#define EVST_EXECUTE	0x10	//vOs
#define EVST_COMMAND	0x20	//R}hs

//---------------------------------------------------------------------------
//[U`bZ[W
#define WM_MCLK_RECYCLE (WM_APP + 200)		//`̍ēǍ

#define MCLOCK_COMMANDLINE	1

//---------------------------------------------------------------------------
typedef DWORD (WINAPI *PF_SETLAYERED)(HWND, DWORD, BYTE, DWORD);


//===========================================================================
// CtH[ NX
//===========================================================================
class TMClockForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TAction *TimeAdjustAction;
	TActionList *ActionList1;
	TApplicationEvents *ApplicationEvents1;
	TMenuItem *AboutItem;
	TMenuItem *CalItem;
	TMenuItem *ChgIniItem;
	TMenuItem *CopyItem;
	TMenuItem *EditItem;
	TMenuItem *GoWebPageItem;
	TMenuItem *Info1Item;
	TMenuItem *Info2Item;
	TMenuItem *Info3Item;
	TMenuItem *Info4Item;
	TMenuItem *Info5Item;
	TMenuItem *QuitItem;
	TMenuItem *RecycleItem;
	TMenuItem *Sep_1;
	TMenuItem *Sep_2;
	TMenuItem *TimeAdjItem;
	TMenuItem *Vinfo1Item;
	TMenuItem *Vinfo2Item;
	TPopupMenu *PopupMenu1;
	TPopupMenu *PopupMenu2;
	TTimer *Timer1;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormDblClick(TObject *Sender);
	void __fastcall EditItemClick(TObject *Sender);
	void __fastcall RecycleItemClick(TObject *Sender);
	void __fastcall QuitItemClick(TObject *Sender);
	void __fastcall PopMeasureItem(TObject *Sender, TCanvas *ACanvas, int &Width, int &Height);
	void __fastcall InfoItemDrawItem(TObject *Sender, TCanvas *ACanvas, TRect &ARect, bool Selected);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall CopyItemClick(TObject *Sender);
	void __fastcall CalItemClick(TObject *Sender);
	void __fastcall CalItemMeasureItem(TObject *Sender, TCanvas *ACanvas, int &Width, int &Height);
	void __fastcall CalItemDrawItem(TObject *Sender, TCanvas *ACanvas, const TRect &ARect, bool Selected);
	void __fastcall VinfoItemDrawItem(TObject *Sender, TCanvas *ACanvas, TRect &ARect, bool Selected);
	void __fastcall GoWebPageItemClick(TObject *Sender);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall TrayIcon1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall TimeAdjustActionExecute(TObject *Sender);
	void __fastcall TimeAdjustActionUpdate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall ApplicationEvents1Hint(TObject *Sender);

private:	// [U[錾
	int VersionNo;

	UnicodeString ExePath;			//st@ĈfBNg

	TTrayIcon *TrayIcon1;			//gCACR

	TFont *TimeFont;				//\tHg
	TFont *InfFont;					//ǉ\tHg

	HRGN hFrmRegion;				//tH[̃[W
	HRGN hDrwRegion;				//`p[W
	int TransAlpha;					//̓x

	int TimeHeight;					//̍
	TEXTMETRIC TmMetric;			//ptHg̃gbN
	int MaxMinSecWidth;				//Ŝ̍ő啝 (:[:b] [am/pm])
	int MaxTimeWidth;				//̍ő啝 (:[:b])
	int MaxInfWidth;				//ǉ̍ő啝

	int TimeAlign;					//̑
	int InfAlign;					//ǉ̑

	int AmPmWidth;					//am/pm\̕
	int AmPmYofs;					//am/pm\\Yʒu
	int AmPmXofs;					//am/pm\\Xʒu
	int	MoonSize;					//̃TCY

	bool Started;					//X^[gtO
	bool SoundPlaying;				//ĐtO
	bool SecUpdate;					//bʂXV

	int	 OrgLeft, OrgTop;

	bool ShowTrayIcon;				//^XNgCACR\
	HICON hTrayIcon;				//^XNgCACR̃nh
	int  DelayTrayIcon;				//NɃ^XNgCACR\x点(G[΍)
	int  RetryTrayIcon;

	TStringList *ScheduleList1;		//\
	TStringList *ScheduleList2;		//\

	UnicodeString InfFormat;		//ǉ񏑎
	UnicodeString InfFormat2;		//ǉ񏑎2

	bool Has_SE_SYSTIME;			//ύX̓Ă

	double TestMoonAage;			//eXg\p̌
	TDateTime TestTime; 			//eXg\p̎

	bool ErrFlag;
	UnicodeString ErrText;

	evnt_tbl EventTable[MAX_EVENT];	//Cxg`e[u
	int EvtTbSize;					//Cxg`

	EventParam *SoundPrm, *WallPaperPrm, *MessagePrm;

	TMenuItem *IniFilItem[10];		//INIt@Cؑւ

	TMenuItem *CalDispItem[38];		//J_[\
	unsigned short CalYear, CalMon;	//NE
	HolidayTable *CalHoliday;		//je[u
	int CalX, CalY;					//\ʒu
	int CaiItmHi;					//ڂ̍
	unsigned short CalMoonTime;		//̎
	THintWindow *CalHint;

	bool HideClock;					//v\
	int  ShowMoon;					//̌`\
	bool MoonShading;				//̌`VF[fBOŕ\
	bool FontShadow; 				//ɉet
	int  FsPosX, FsPosY;			//ȇΈʒu
	bool InfShadow;					//ǉɉet
	int  InfFsPosX, InfFsPosY;		//ȇΈʒu
	int  Hour12;					//12ԕ\
	int	 MarginX, MarginY;			//XY}[W
	bool HideApp;					//AvƂĕ\Ȃ
	bool MouseHide;					//}EXŉB
	bool ShowSec;					//b\
	int  BeatInterval;				//񉹌JԂ(b)  0:JԂ
	bool ShowKoyomiTip;				//c[`bvɗ\
	bool ShowScheduleTip;			//c[`bvɗ\\@
	bool ShowChangeYear;			//uO/̔Nv\

	mooninf MoonInfo;				//݂̌
	unsigned short CurYear, CurMon, CurDay;	//݂̓t
	int  CurWek;					//݂̗j(1`7)
	HolidayTable *CurHoliday;		//N̏je[u
	KoyomiUnit   *Koyomi;			//
	TDateTime CurTime;				//ݎ
	unsigned short CurHour, CurMin, CurSec, CurMsc;
	unsigned short LstMin;
	long StartCount, CurCount, LstCount;
	long NxtDwnCount;				//Cxg܂ł̎cJEg
	int  BeatCount;					//񉹌JԂĐpJE^

	void __fastcall WmQueryEndSession(TMessage &msg);
	void __fastcall WmCopyData(TMessage &msg);
	void __fastcall WmMciNotify(TMessage& msg);
	void __fastcall WmMclkRecycle(TMessage& msg);

	int  __fastcall ReadEventCfg(const UnicodeString sct, int typ, int tidx);
	void __fastcall InitEventTable();
	bool __fastcall PlayEventSound(const UnicodeString ev_id);
	bool __fastcall ChangeWallPaper(const UnicodeString ev_id);
	bool __fastcall ShowMsgBoard(const UnicodeString ev_id);
	int  __fastcall DoEventAction(const int evn);
	void __fastcall UpdateNow();
	void __fastcall UpdateMoonInfo();
	bool __fastcall UpdateTrayIcon(DWORD dwMessage);
	void __fastcall CalNextMItemClick(TObject *Sender);
	void __fastcall CalPrevMItemClick(TObject *Sender);
	void __fastcall CalNextYItemClick(TObject *Sender);
	void __fastcall CalPrevYItemClick(TObject *Sender);

public:		// [U[錾
	Graphics::TBitmap *BgImage; 	//wiC[W
	Graphics::TBitmap *MoonImage;	//̃C[W
	Graphics::TBitmap *ShadowImage;	//̉ẽC[W

	TColor ColFrame;				//g̐F
	TColor ColMoon; 				//̐F
	TColor ColShadow;				//̉e̐F
	TColor ColFntPly;				//Đ̎F
	TColor ColFntShd;				//̉e̐F
	TColor ColInfShd;				//ǉ̉e̐F

	bool StayOnTop;					//Ɉԏɕ\

	__fastcall TMClockForm(TComponent* Owner);
	void __fastcall RecyclePrc(TObject *Sender);
	void __fastcall IniFilItemClick(TObject *Sender);
	void __fastcall ExpFormChar(UnicodeString &s);
	int  __fastcall GetMaxFormWidth(TCanvas *cv, UnicodeString s);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_QUERYENDSESSION, TMessage, WmQueryEndSession)
		VCL_MESSAGE_HANDLER(WM_COPYDATA,	 	TMessage, WmCopyData)
		VCL_MESSAGE_HANDLER(MM_MCINOTIFY,	 	TMessage, WmMciNotify)
		VCL_MESSAGE_HANDLER(WM_MCLK_RECYCLE,	TMessage, WmMclkRecycle)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMClockForm *MClockForm;
//---------------------------------------------------------------------------
#endif
