//----------------------------------------------------------------------//
// Cxgp[^ NX											//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "EvParam.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
EventParam::EventParam(const char *prm_id)
{
	PrmName  = prm_id;
	IniFile  = NULL;
	ListSize = CurIndex = 0;
}
//---------------------------------------------------------------------------
EventParam::~EventParam()
{
}

//---------------------------------------------------------------------------
// Xg̎ǂݍ
//---------------------------------------------------------------------------
void EventParam::AutoRegister(UnicodeString fmask)
{
	if (IniFile) {
		UnicodeString sct = PrmName + "List";
		std::unique_ptr<TStringList> TmpList(new TStringList());
	 	//wt@Cǂݍ
		UnicodeString ld_fil = IniFile->ReadString(sct, "AutoRegFile");
		if (get_file_name_r(ld_fil)) { 
		 	TmpList->Sorted = false;
		 	TmpList->LoadFromFile(ld_fil);
		}
		//wfBNg̃t@C擾
		else {
		 	TmpList->Sorted = true;
			UnicodeString ld_dir = IniFile->ReadString(sct, "AutoRegDir");
			if (!ld_dir.IsEmpty() && !fmask.IsEmpty()) {
				if (ExtractFileDrive(ld_dir).IsEmpty())
					ld_dir = ExtractFilePath(Application->ExeName) + ld_dir;
				ld_dir = IncludeTrailingPathDelimiter(ld_dir);
				for (;;) {
					UnicodeString msk;
					int p = fmask.Pos(";");
					if (p>0) {
						msk = fmask.SubString(1, p - 1);
						fmask.Delete(1, p);
					}
					else {
						msk   = fmask;
						fmask = EmptyStr;
					}
					if (msk.IsEmpty()) break;

					TSearchRec sr;
					if (FindFirst(ld_dir + msk, 0, sr) == 0) {
						do TmpList->Add(ld_dir + sr.Name); while (FindNext(sr) == 0);
					    FindClose(sr);
					}
				}
			}
		}
		if (TmpList->Count>0) {
			//XgXV
			int i;
			for (i=0; i<TmpList->Count; i++)
				IniFile->WriteString(sct, PrmName + IntToStr(i + 1), TmpList->Strings[i]);
			//svȃL[΍폜
			i = TmpList->Count + 1;
			while (!IniFile->ReadString(sct, PrmName + IntToStr(i)).IsEmpty())
				IniFile->DeleteKey(sct, PrmName + IntToStr(i++));
			IniFile->UpdateFile();
		}
	}
}

//---------------------------------------------------------------------------
// Xg̓o^JEg
//---------------------------------------------------------------------------
void EventParam::CountList()
{
	ListSize = CurIndex = 0;
	if (IniFile) {
		while (!IniFile->ReadString(PrmName + "List", PrmName + IntToStr(ListSize + 1)).IsEmpty())
			ListSize++;
	}
}
//---------------------------------------------------------------------------
// wCxg̃p[^擾
//---------------------------------------------------------------------------
bool EventParam::GetParam(const UnicodeString evt_id, UnicodeString &result)
{
	if (!IniFile) return false;
	result = IniFile->ReadString(evt_id, PrmName);
	if (result.IsEmpty()) return false;
	if (result=="none")
		result = EmptyStr;
	else if (result=="next" || result=="random") {
		if (ListSize==0) return false;
		CurIndex = ((result=="next") ? (CurIndex % ListSize) : random(ListSize)) + 1;
		result = IniFile->ReadString(PrmName + "List", PrmName + IntToStr(CurIndex));
	}
	return true;
}
//---------------------------------------------------------------------------
