//----------------------------------------------------------------------//
// gƔwiw肵ătH[`										//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include "frmdraw.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
void LoadDrawInf(drwinf *dinf, UsrIniFile *inifil, UnicodeString sct)
{
	dinf->region = NULL;
	dinf->frm_style = FSTY_NONE;
	UnicodeString frmstyl = inifil->ReadString(sct, "FrmStyle");
	if		(frmstyl=="Normal")	   dinf->frm_style = FSTY_NORMAL;
	else if (frmstyl=="Single")	   dinf->frm_style = FSTY_SINGLE;
	else if (frmstyl=="Double")	   dinf->frm_style = FSTY_DOUBLE;
	else if (frmstyl=="Triple")	   dinf->frm_style = FSTY_TRIPLE;
	else if (frmstyl=="Gradation") dinf->frm_style = FSTY_GRADATION;
	dinf->frm_width = inifil->ReadInteger(sct, "FrmWidth", 8);
	for (int i=0; i<6; i++)
		dinf->frm_col[i]
			= (inifil->ReadColor(sct, "FrmColor" + IntToStr(i + 1), (TColor)0xff0000));
	dinf->stretch_img = inifil->ReadBool(sct, "StretchImage",true);
}

//---------------------------------------------------------------------------
void DrawFormEx(drwinf *dinf)
{
	int wd		= dinf->frm_width;
	TCanvas *cv = dinf->form->Canvas;
	TRect rc	= dinf->form->ClientRect;

	//--------------
	//wi̕`
	//--------------
	//摜
	if (dinf->img->Empty) {
		cv->Brush->Style = bsSolid;
		cv->Brush->Color = dinf->form->Color;
		cv->FillRect(rc);
	}
	//摜L
	else {
		TRect imgrc = rc;
		if (dinf->frm_style!=0) imgrc.Inflate(-(wd - 1), -(wd - 1));
		//O`ɍ킹
		if (dinf->stretch_img)
			cv->StretchDraw(imgrc, dinf->img);
		//ׂĕ~l߂
		else {
			for(int x=0; x<imgrc.Right; x+=dinf->img->Width) {
				for(int y=0; y<imgrc.Bottom; y+=dinf->img->Height)
					cv->Draw(x, y, dinf->img);
			}
		}
	}

	//--------------
	//Og̕`
	//--------------
	int x0 = 0;
	int y0 = 0;
	int x1 = rc.Width();
	int y1 = rc.Height();
	int n,i, x2, y2, c1, c2, r1, g1, b1, dr, dg, db, gwd;
	TPoint ps[7];

	switch (dinf->frm_style) {
	case FSTY_NORMAL:
		//Pg
		cv->Brush->Color = dinf->frm_col[0];
		if (dinf->region)
			::FrameRgn(cv->Handle, dinf->region, cv->Brush->Handle, wd, wd);
		else {
			HRGN hTempRgn = ::CreateRectRgn(0, 0, x1, y1);
			::FrameRgn(cv->Handle, hTempRgn, cv->Brush->Handle, wd, wd);
			::DeleteObject(hTempRgn);
		}
		break;

	case FSTY_SINGLE: case FSTY_DOUBLE: case FSTY_TRIPLE:
		//̘g
		x1--; y1--; wd--;
		switch (dinf->frm_style) {
		case FSTY_DOUBLE: wd/=2; n=2; break;
		case FSTY_TRIPLE: wd/=3; n=3; break;
		default: n=1;
		}
		for (i=0; i<n; i++) {
			//
			ps[0] = Point(x0,	   y0);
			ps[1] = Point(x1,	   y0);
			ps[2] = Point(x1 - wd, y0 + wd);
			ps[3] = Point(x0 + wd, y0 + wd);
			ps[4] = Point(x0 + wd, y1 - wd);
			ps[5] = Point(x0,	   y1);
			cv->Brush->Color = dinf->frm_col[i*2];
			cv->Pen->Color = cv->Brush->Color;
			cv->Polygon(ps, 5);
			//E
			ps[0] = Point(x1,	   y1);
			ps[1] = Point(x1,	   y0);
			ps[2] = Point(x1 - wd, y0 + wd);
			ps[3] = Point(x1 - wd, y1 - wd);
			ps[4] = Point(x0 + wd + 1, y1 - wd);
			ps[5] = Point(x0+1,	   y1);
			cv->Brush->Color = dinf->frm_col[i*2 + 1];
			cv->Pen->Color = cv->Brush->Color;
			cv->Polygon(ps, 5);
			x0 += wd; y0 += wd; x1 -= wd; y1 -= wd;
		}
		break;

	case FSTY_GRADATION:
		//Of[V
		c1 = dinf->frm_col[0];
		c2 = dinf->frm_col[1];
		r1 = GetRValue(c1); dr = GetRValue(c2) - r1;
		g1 = GetGValue(c1); dg = GetGValue(c2) - g1;
		b1 = GetBValue(c1); db = GetBValue(c2) - b1;
		x2 = x1; y2 = y1-1; wd--;
		gwd = wd - 1; if (gwd<1) gwd = 1;
		for (i=0; i<wd; i++) {
			cv->Pen->Color = TColor(RGB(r1 + dr*i/(gwd), g1 + dg*i/(gwd), b1 + db*i/(gwd)));
			ps[0] = Point(i, 	y2--);
			ps[1] = Point(i,	i);
			ps[2] = Point(x2--, i);
			cv->Polyline(ps, 2);
		}
		x2 = x1 - 1;
		y2 = y1 - 1;
		c1 = dinf->frm_col[3];
		c2 = dinf->frm_col[2];
		r1 = GetRValue(c1); dr = GetRValue(c2) - r1;
		g1 = GetGValue(c1); dg = GetGValue(c2) - g1;
		b1 = GetBValue(c1); db = GetBValue(c2) - b1;
		for (i=0; i<wd; i++) {
			cv->Pen->Color = TColor(RGB(r1 + dr*i/(gwd), g1 + dg*i/(gwd), b1 + db*i/(gwd)));
			ps[0] = Point(i + 1, y2);
			ps[1] = Point(x2,	 y2--);
			ps[2] = Point(x2--,  i);
			cv->Polyline(ps, 2);
		}
		break;
	}
}
//---------------------------------------------------------------------------

